/*
 * Copyright 2012 Giorgio Vazzana
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/* Compile: gcc -Wall -O ascii_to_bin.c -o ascii_to_bin */

#include <stdio.h>
#include <stdint.h>

uint8_t read_uint8(int *reached_eof)
{
	int i, c;
	uint8_t value = 0;

	for (i = 0; i < 8; i++) {
		c = fgetc(stdin);
		c = (c == '0') ? 0 : 1;
		value = (value << 1) | c;
		c = fgetc(stdin); /* \n */
		if (c == EOF) {
			*reached_eof = 1;
			break;
		}
	}
	return value;
}


int main(int argc, char *argv[])
{
	uint8_t byte;
	int reached_eof = 0;

	while (1) {
		byte = read_uint8(&reached_eof);
		if (reached_eof)
			break;

		fwrite(&byte, sizeof(byte), 1, stdout);
	}

	return 0;
}
